BEGIN {
  # key: [String] pod name
  # value: [Hash] git address and commit/tag/...
  $pods_git_source = {}
}



module Pod
  class Specification

    # hook method to record pod git sources
    #
    old_root = instance_method(:root)
    define_method(:root) do
      result = old_root.bind(self).()
      bd_record_source
      return result
    end

    private
    def bd_record_source

      if !$pods_git_source[attributes_hash['name']]

        source = attributes_hash['source'] #获取source的数据源
        if source
          unless source.keys.include?('git')
            source = attributes_hash['source_code']# 如果获取不到source的数据源就尝试获取source_code中记录的，这里不能支持官方的zip源
            debug_source = attributes_hash['source'] # 记录zip地址用于转化
          end

        end
        source = attributes_hash['source_code'] if !source # 兜底方案，如果没有source的话尝试取source_code

        $pods_git_source[attributes_hash['name']] = source if source
        $Debug_Record[attributes_hash['name']] = debug_source if debug_source
      end

    end

  end
end




Pod::HooksManager.register('cocoapods-bytedance-Slardar', :post_install) do |installer_context|

  if ENV['WORKSPACE'] || ENV.has_key?('CI_JOB_NAME')

    pods_git_source = $pods_git_source

    # After pod install, the manifest file is the same with podfilelock
    lockfile = Pod::Lockfile.from_file(installer_context.sandbox.manifest_path)
    checkout_data = lockfile.send :checkout_options_data
    checkout_data.each do |pod_name, hash|
      pods_git_source[pod_name] = hash
    end

    # write to file
    sandbox_root = File.dirname(installer_context.sandbox_root)
    filename = "pod.json"
    File.write(Pathname.new(sandbox_root) + filename, pods_git_source.to_json)

    cmd = "
    root=`git rev-parse --show-toplevel`
    cd $root
    curl -o ParseProjectFileMap http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/#{BDPodExtentions::VERSION}/ParseProjectFileMap
    chmod 777 ParseProjectFileMap
    find ./ -type f|egrep -v \".svn|.git|.png|.plist|.strings|vendor/bundle\" > context.txt
    commit=`git rev-parse HEAD`
    git=`git remote -v |xargs -n 1|egrep 'git' |head -n 1`
    ./ParseProjectFileMap $root/context.txt #{sandbox_root}/#{filename} $git $commit
    if [[ $? -ne 0 ]]; then
      curl -X GET -G --data-urlencode \"text=$git\" --data-urlencode \"username=wusizhen.arch\" \"https://ios.bytedance.net/wlapi/sendMessage\"
      fi
      "
    system(cmd)
  end

end
