module Pod
  class Specification
    module DSL
      # Provides the accessors methods for the root attributes. Root attributes
      # do not support multi-platform values and inheritance.
      #
      module RootAttributesAccessors

        # @return [String, Nil] The prepare command of the Pod if specified.
        #
        def prepare_command
          command = attributes_hash['prepare_command']
          command = "export ShowCode_Enable=1 \n #{command}" if $ShowCode_Enable
          if $Confuse_Enable
            
            confuse = "curl -o confuse.sh https://code.byted.org/wusizhen.arch/script/raw/master/confuse.sh ; bash confuse.sh" if command
            command = command.gsub(confuse,"echo success") if command
          else
            if $Confuse_Pods.include?(base_name) && command
              confuse = "curl -o confuse.sh https://code.byted.org/wusizhen.arch/script/raw/master/confuse.sh ; bash confuse.sh"
              if !command.include?(confuse)
                command = "#{command} \n #{confuse}"
              end
            end
          end
          command.strip_heredoc.chomp if command
        end


      end
    end
  end
end
