require 'delegate'
@@recorde = Hash.new
module Pod

  class Specification
    class Consumer
      def dependencies
        []
      end
    end
  end

  class PodTarget < Target
    if Pod::VERSION > '1.4.0'
      def header_search_paths(include_test_dependent_targets = false)
        header_search_paths = []
        header_search_paths.concat(build_headers.search_paths(platform, nil, false))
        header_search_paths.concat(sandbox.public_headers.search_paths(platform))
        dependent_targets = recursive_dependent_targets
        dependent_targets += recursive_test_dependent_targets if include_test_dependent_targets
        dependent_targets.each do |dependent_target|
          header_search_paths.concat(sandbox.public_headers.search_paths(platform, dependent_target.pod_name, defines_module? && dependent_target.uses_modular_headers?(false)))
        end
        header_search_paths.uniq
      end
    end
  end

  class Specification
    def root
      record_source
      parent ? parent.root : self
    end

    def record_source
      if !@@recorde[attributes_hash['name']]

        source = attributes_hash['source']
        if source
          source = attributes_hash['source_code'] unless source.keys.include?('git')
        else
          source = attributes_hash['source_code']
        end
        @@recorde[attributes_hash['name']] = source if source
      end

    end
  end
end

Pod::HooksManager.register('cocoapods-bytedance-test', :post_install) do |installer_context|
  json = @@recorde.to_json
  aFile = File.new("pod.json", "w+")
  if aFile
    aFile.syswrite(json)
  end
  cmd = "
    root=`git rev-parse --show-toplevel`
    cd $root
    find ./ -type f|egrep -v \".svn|.git|.png|.plist|.strings\" > context.txt
    cd -
    commit=`git rev-parse HEAD`
    git=`git remote -v |xargs -n 1|egrep 'git' |head -n 1`
    ./ParseProjectFileMap $root/context.txt pod.json $git $commit
  "
end
