#!/usr/bin/ruby

# merge the content in lib/main.rb into one file

require 'pathname'

lib_path = Pathname.new(__FILE__).dirname + "lib"
subfolder = lib_path + "bd_pod_extentions"
main = File.read(subfolder + "main.rb")
names = main.split("\n").select {|line| line.start_with? "require_relative" }.map do |line|
    name = line.split(" ")[1].gsub("\'", "").gsub("\"", "").strip
    name += ".rb" unless name.end_with? ".rb"
    name
end

contents = "# This file is generated automatically. DO NOT EDIT MANUALLY!\n"
contents += "# This file combines the contents of:\n"
contents += names.map { |n| "#     - #{n}"}.join("\n")

names.each do |name|
    file_path = (subfolder + name).realpath
    contents += "\n\n# ----- contents of '#{name}' -------- \n\n"
    contents += File.read(file_path)
end
contents += "# This file is generated automatically. DO NOT EDIT MANUALLY!\n"

File.write(lib_path + 'bd_pod_extension_net.rb', contents)
